/*
 * API documentation
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0-20181108155220-20181108155343
 * Contact: api.move@axa-assistance.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.insurance.bn.starter.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import org.threeten.bp.LocalDate;

import java.util.Objects;

/**
 * Information related to the travel
 */
@ApiModel(description = "Information related to the travel")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2018-12-19T23:23:06.995+01:00")
public class Model139 {
  @SerializedName("from")
  private LocalDate from = null;

  @SerializedName("to")
  private LocalDate to = null;

  @SerializedName("is_one_way_travel")
  private Boolean isOneWayTravel = null;

  @SerializedName("country_origin")
  private String countryOrigin = null;

  @SerializedName("city_origin")
  private String cityOrigin = null;

  @SerializedName("country_destination")
  private String countryDestination = null;

  @SerializedName("city_destination")
  private String cityDestination = null;

  @SerializedName("is_international_trip")
  private Boolean isInternationalTrip = null;

  @SerializedName("cost")
  private Model136 cost = null;

  public Model139 from(LocalDate from) {
    this.from = from;
    return this;
  }

   /**
   * Starting date of the travel - ISO 8601 format (YYYY-MM-DD)
   * @return from
  **/
  @ApiModelProperty(example = "2017-05-01", required = true, value = "Starting date of the travel - ISO 8601 format (YYYY-MM-DD)")
  public LocalDate getFrom() {
    return from;
  }

  public void setFrom(LocalDate from) {
    this.from = from;
  }

  public Model139 to(LocalDate to) {
    this.to = to;
    return this;
  }

   /**
   * Ending date of the travel - ISO 8601 format (YYYY-MM-DD)
   * @return to
  **/
  @ApiModelProperty(example = "1989-05-09", value = "Ending date of the travel - ISO 8601 format (YYYY-MM-DD)")
  public LocalDate getTo() {
    return to;
  }

  public void setTo(LocalDate to) {
    this.to = to;
  }

  public Model139 isOneWayTravel(Boolean isOneWayTravel) {
    this.isOneWayTravel = isOneWayTravel;
    return this;
  }

   /**
   * Is it a one way travel ?
   * @return isOneWayTravel
  **/
  @ApiModelProperty(example = "true", value = "Is it a one way travel ?")
  public Boolean isIsOneWayTravel() {
    return isOneWayTravel;
  }

  public void setIsOneWayTravel(Boolean isOneWayTravel) {
    this.isOneWayTravel = isOneWayTravel;
  }

  public Model139 countryOrigin(String countryOrigin) {
    this.countryOrigin = countryOrigin;
    return this;
  }

   /**
   * Country of origin of the trip - ISO-3166-1 alpha-2 format (2 letter codes)
   * @return countryOrigin
  **/
  @ApiModelProperty(example = "fr", value = "Country of origin of the trip - ISO-3166-1 alpha-2 format (2 letter codes)")
  public String getCountryOrigin() {
    return countryOrigin;
  }

  public void setCountryOrigin(String countryOrigin) {
    this.countryOrigin = countryOrigin;
  }

  public Model139 cityOrigin(String cityOrigin) {
    this.cityOrigin = cityOrigin;
    return this;
  }

   /**
   * City of origin of the trip
   * @return cityOrigin
  **/
  @ApiModelProperty(example = "paris", value = "City of origin of the trip")
  public String getCityOrigin() {
    return cityOrigin;
  }

  public void setCityOrigin(String cityOrigin) {
    this.cityOrigin = cityOrigin;
  }

  public Model139 countryDestination(String countryDestination) {
    this.countryDestination = countryDestination;
    return this;
  }

   /**
   * Country of destination of the trip - ISO-3166-1 alpha-2 format (2 letter codes)
   * @return countryDestination
  **/
  @ApiModelProperty(example = "en", value = "Country of destination of the trip - ISO-3166-1 alpha-2 format (2 letter codes)")
  public String getCountryDestination() {
    return countryDestination;
  }

  public void setCountryDestination(String countryDestination) {
    this.countryDestination = countryDestination;
  }

  public Model139 cityDestination(String cityDestination) {
    this.cityDestination = cityDestination;
    return this;
  }

   /**
   * City of destination of the trip
   * @return cityDestination
  **/
  @ApiModelProperty(example = "london", value = "City of destination of the trip")
  public String getCityDestination() {
    return cityDestination;
  }

  public void setCityDestination(String cityDestination) {
    this.cityDestination = cityDestination;
  }

  public Model139 isInternationalTrip(Boolean isInternationalTrip) {
    this.isInternationalTrip = isInternationalTrip;
    return this;
  }

   /**
   * Define if the trip is international (in opposition of domestic)
   * @return isInternationalTrip
  **/
  @ApiModelProperty(example = "false", value = "Define if the trip is international (in opposition of domestic)")
  public Boolean isIsInternationalTrip() {
    return isInternationalTrip;
  }

  public void setIsInternationalTrip(Boolean isInternationalTrip) {
    this.isInternationalTrip = isInternationalTrip;
  }

  public Model139 cost(Model136 cost) {
    this.cost = cost;
    return this;
  }

   /**
   * Get cost
   * @return cost
  **/
  @ApiModelProperty(value = "")
  public Model136 getCost() {
    return cost;
  }

  public void setCost(Model136 cost) {
    this.cost = cost;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Model139 model139 = (Model139) o;
    return Objects.equals(this.from, model139.from) &&
        Objects.equals(this.to, model139.to) &&
        Objects.equals(this.isOneWayTravel, model139.isOneWayTravel) &&
        Objects.equals(this.countryOrigin, model139.countryOrigin) &&
        Objects.equals(this.cityOrigin, model139.cityOrigin) &&
        Objects.equals(this.countryDestination, model139.countryDestination) &&
        Objects.equals(this.cityDestination, model139.cityDestination) &&
        Objects.equals(this.isInternationalTrip, model139.isInternationalTrip) &&
        Objects.equals(this.cost, model139.cost);
  }

  @Override
  public int hashCode() {
    return Objects.hash(from, to, isOneWayTravel, countryOrigin, cityOrigin, countryDestination, cityDestination, isInternationalTrip, cost);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Model139 {\n");
    
    sb.append("    from: ").append(toIndentedString(from)).append("\n");
    sb.append("    to: ").append(toIndentedString(to)).append("\n");
    sb.append("    isOneWayTravel: ").append(toIndentedString(isOneWayTravel)).append("\n");
    sb.append("    countryOrigin: ").append(toIndentedString(countryOrigin)).append("\n");
    sb.append("    cityOrigin: ").append(toIndentedString(cityOrigin)).append("\n");
    sb.append("    countryDestination: ").append(toIndentedString(countryDestination)).append("\n");
    sb.append("    cityDestination: ").append(toIndentedString(cityDestination)).append("\n");
    sb.append("    isInternationalTrip: ").append(toIndentedString(isInternationalTrip)).append("\n");
    sb.append("    cost: ").append(toIndentedString(cost)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

